/***************************************************************************
                     accountmananger.h  -  description
                             -------------------
    begin                : Sat Apr 28 19:10:24 EDT 2001
    copyright            : (C) 2001 by Mike Pilone
    email                : mpilone@slac.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ACCOUNT_MANAGER_H
#define ACCOUNT_MANAGER_H

#include <qobject.h>
#include <qlist.h>
#include <qvaluelist.h>

#include "filtermanager.h"
#include "pluginmanager.h"
#include "knmmessage.h"

class KNMPlugin;
class KConfig;
class KNMProtocol;

class AccountManager : public PluginManager
  {
  Q_OBJECT
  
  public:
    AccountManager(QObject *parent, const char *name);
  ~AccountManager();

  void checkMessages();
  void cancelCheck();
    
  void initPlugin(KNMPlugin *plugin);
    
  bool isChecking();

  void markMessageForDelete(Q_UINT32 msgID);
  void unmarkMessageForDelete(Q_UINT32 msgID);

 public slots:
 void slotMessageReceived(KNMMessage *msg);
  void slotDoneChecking(bool success, Q_UINT32 accountID);
  void slotDoneDeleting(bool success, Q_UINT32 accountID);
  
    signals:
  void doneChecking(QList<KNMMessage> &msgs);

      protected:
    virtual QString getManagedPluginType()   { return "Account"; }
    virtual QString getManagedResourceType() { return "protocols"; }
    
    private:
    void deleteAndCheckMail(KNMProtocol &acct);
 
  FilterManager _filterManager;
    QList<KNMMessage> _messageList;
    
    QValueList<Q_UINT32> _deletingAccountList;
    QValueList<Q_UINT32> _checkingAccountList;

  bool _cancelingCheck;
  };

#endif
