/***************************************************************************
                     configdialog.cpp  -  description
                             -------------------
    begin                : Sat Apr 28 19:10:24 EDT 2001
    copyright            : (C) 2001 by Mike Pilone
    email                : mpilone@slac.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFIG_DIALOG_H
#define CONFIG_DIALOG_H

#include <qlist.h>

#include <kdialogbase.h>

#include "configpage.h"

class AccountManager;
class NotifierManager;

class KConfig;

class ConfigDialog : public KDialogBase
  {
    Q_OBJECT
    
  public:
  ConfigDialog(AccountManager *accountMgr,
	       NotifierManager *notifierMgr,
	       QWidget *parent,
	       const char *name);
    ~ConfigDialog();

 protected slots:
 virtual void slotOk();
    virtual void slotApply();
    void slotModified();
    
      private:
    void initPages(AccountManager *accountMgr,
		   NotifierManager *notifierMgr);
 
    void readOptions(KConfig &config);
    void writeOptions(KConfig &config);

    QList<ConfigPage> _configPageList;

    bool _modified;
  };

#endif
