/***************************************************************************
                       configpluginspage.h  -  description
                             -------------------
    begin                : Sat Apr 28 19:10:24 EDT 2001
    copyright            : (C) 2001 by Mike Pilone
    email                : mpilone@slac.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFIG_PLUGINSPAGE_H
#define CONFIG_PLUGINSPAGE_H

#include <qlist.h>
#include <qstringlist.h>

#include <kdialogbase.h>

#include "knmplugin.h"
#include "configpage.h"

class QListView;
class QPushButton;
class PluginManager;

class ConfigPluginsPage : public ConfigPage
  {
    Q_OBJECT
    
      public:
    ConfigPluginsPage(PluginManager *notifierMgr,
		       QWidget *parent, const char *name);
    ~ConfigPluginsPage();

    virtual void readOptions(KConfig &config);
    virtual void writeOptions(KConfig &config);

     protected slots:
 void slotAddButtonClicked();
    void slotRemoveButtonClicked();
    void slotModifyButtonClicked();
    void slotListViewCurrentChanged(QListViewItem *);
    
    
      private:
   QListView *_pluginListView;

    QPushButton *_addButton;
    QPushButton *_removeButton;
    QPushButton *_modifiyButton;
    
    QList<KNMPlugin> _pluginList;

    PluginManager *_pluginMgr;
  };

class AddPluginDialog : public KDialogBase
  {
      public:
    AddPluginDialog(PluginManager *pluginMgr,
		     QWidget *parent, const char *name);
    ~AddPluginDialog() {}

    QString getSelectedPlugin();

      private:
    QButtonGroup *_buttonGroup;
  };

#endif
