/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Sat Apr 28 19:10:24 EDT 2001
    copyright            : (C) 2001 by Mike Pilone
    email                : mpilone@slac.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qstring.h>

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>
#include <kglobal.h>
#include <kstddirs.h>
#include <kdebug.h>

#ifdef HAVE_CONFIG_H
#include <config.h>
#else
#define VERSION "?.?"
#endif

#include "knewmail.h"

static const QString &description = KGlobal::staticQString(
     QString("KNewMail v") + QString(VERSION) +
     QString("\nMail monitoring and notification utility."));

//static const char *description =
//	I18N_NOOP("KNewMail\nMail monitoring and notification utility.");
	
	
static KCmdLineOptions options[] =
{
  { "+[File]", I18N_NOOP("file to open"), 0 },
  { 0, 0, 0 }
  // INSERT YOUR COMMANDLINE OPTIONS HERE
};

int main(int argc, char *argv[])
  {
  KAboutData aboutData( "knewmail", I18N_NOOP("KNewMail"),
			VERSION, description.latin1(), KAboutData::License_GPL,
			"(c) 2001, Mike Pilone", 0, 0, "mpilone@slac.com");
  aboutData.addAuthor("Mike Pilone",0, "mpilone@slac.com");
  KCmdLineArgs::init( argc, argv, &aboutData );
  
  // Add our own options.
  KCmdLineArgs::addCmdLineOptions( options ); 

  KApplication app;
  
  // Add resource types
  KGlobal::dirs()->addResourceType("protocols",
				   KStandardDirs::kde_default("data")
					   + "knewmail/protocols");
  
  KGlobal::dirs()->addResourceType("notifiers",
				   KStandardDirs::kde_default("data")
					   + "knewmail/notifiers");
 
  if (app.isRestored())
  {
    RESTORE(KNewMailApp);
  }
  else 
  {
    (void) new KNewMailApp();
    
    // The app will handle showing itself, because it might just start
    // minimized
    
    //knewmail->show();
  }

  return app.exec();
}  
