/***************************************************************************
                     notifiermananger.h  -  description
                             -------------------
    begin                : Sat Apr 28 19:10:24 EDT 2001
    copyright            : (C) 2001 by Mike Pilone
    email                : mpilone@slac.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NOTIFIER_MANAGER_H
#define NOTIFIER_MANAGER_H

#include <qlist.h>
#include <qobject.h>

#include "pluginmanager.h"
#include "knmmessage.h"

class KNMPlugin;
class KConfig;

class NotifierManager : public PluginManager
  {
  Q_OBJECT
  
    public:
  NotifierManager(QObject *parent, const char *name);
  ~NotifierManager();

    void initPlugin(KNMPlugin *plugin);
   
  void updateState(QList<KNMMessage> &msgs);
  void updateMarkMessageForDelete(Q_UINT32 msgID);
  void updateUnmarkMessageForDelete(Q_UINT32 msgID);

  public slots:
  void slotForceCheck();
  void slotMarkMessageForDelete(Q_UINT32 msgID);
  void slotUnmarkMessageForDelete(Q_UINT32 msgID);
    
  signals:
  void forceCheck();
  void markMessageForDelete(Q_UINT32 msgID);
  void unmarkMessageForDelete(Q_UINT32 msgID);

      protected:
    virtual QString getManagedPluginType()   { return "Notifier"; }
    virtual QString getManagedResourceType() { return "notifiers"; }
  };

#endif
