/***************************************************************************
                   knmanimdocknotifier.cpp -  description
                             -------------------
    begin                : Sat Apr 28 19:10:24 EDT 2001
    copyright            : (C) 2001 by Mike Pilone
    email                : mpilone@slac.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kconfig.h>
#include <kmainwindow.h>
#include <kmessagebox.h>
#include <klocale.h>
#include <kicontheme.h>
#include <kwin.h>

#include "knmanimdocknotifier.h"
#include "animwidget.h"

extern "C" {
  KNMPluginInfo *initAnimDockPluginInfo(QObject *parent)
    {
    return new KNMPluginInfo("AnimDock",
			     "Displays a small animation docked in the panel.",
			     "Mike Pilone <mpilone@slac.com>", "1.0.0",
			     parent, "knmanimdocknotifierinfo");
    }
  
  KNMNotifier *initAnimDockPlugin(KMainWindow *parent)
    {
    return new KNMAnimDockNotifier(parent, "knmanimdocknotifier");
    }
}

KNMAnimDockNotifier::KNMAnimDockNotifier(KMainWindow *parent, const char *name)
  : KNMNotifier(initAnimDockPluginInfo(parent), parent, name),
    _panelAnim(NULL)
  {
  }

KNMAnimDockNotifier::~KNMAnimDockNotifier()
  {
  if (_panelAnim != NULL)
    delete _panelAnim;
  }

void KNMAnimDockNotifier::readOptions(KConfig &config)
  {
  KNMNotifier::readOptions(config);
  }

void KNMAnimDockNotifier::writeOptions(KConfig &config)
  {
  KNMNotifier::writeOptions(config);
  }

void KNMAnimDockNotifier::updateState(QList<KNMMessage> &msgs)
  {
  if (_panelAnim)
    {
    if (msgs.count() > 0)
      _panelAnim->start();
    else
      _panelAnim->stop();
    }
  }

void KNMAnimDockNotifier::updateMarkMessageForDelete(Q_UINT32)
  {
  // no-op
  }

void KNMAnimDockNotifier::updateUnmarkMessageForDelete(Q_UINT32)
  {
  // no-op
  }

void KNMAnimDockNotifier::initGUI()
  {
  _panelAnim = new AnimWidget(QString("kde"), NULL, "panelAnim");
  _panelAnim->show();

  KWin::setSystemTrayWindowFor( _panelAnim->winId(), 0 );
  }
