/***************************************************************************
                 knmlistviewnotifier.h  -  description
                             -------------------
    begin                : Sat Apr 28 19:10:24 EDT 2001
    copyright            : (C) 2001 by Mike Pilone
    email                : mpilone@slac.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KNM_NUMBERDOCK_NOTIFIER_H
#define KNM_NUMBERDOCK_NOTIFIER_H

#include <qlist.h>

#include "knmmessage.h"
#include "knmnotifier.h"

class KMainWindow;
class KConfig;
class KListView;

class KNMListViewNotifier : public KNMNotifier
  {
  Q_OBJECT
  
    public:
  KNMListViewNotifier(KMainWindow *parent, const char *name);
  ~KNMListViewNotifier();

    virtual void readOptions(KConfig &);
  virtual void writeOptions(KConfig &);
  
  virtual void updateState(QList<KNMMessage> &msgs);
  virtual void updateMarkMessageForDelete(Q_UINT32 msgID);
  virtual void updateUnmarkMessageForDelete(Q_UINT32 msgID);

    virtual void initGUI();

 protected slots:
 void slotItemDoubleClicked(QListViewItem *);
  
    private:
  void setItemPixmap(bool on, Q_UINT32 msgID);
  
  KListView *_listView;
  KMainWindow *_mainWin;
  };

#endif
