/***************************************************************************
                         knmprotocol.cpp  -  description
                             -------------------
    begin                : Sat Apr 28 19:10:24 EDT 2001
    copyright            : (C) 2001 by Mike Pilone
    email                : mpilone@slac.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "knmprotocol.h"

KNMProtocol::KNMProtocol(KNMPluginInfo *info,
			 QObject *parent, const char *name)
  : KNMPlugin(info, parent, name),
    _checking(false), _deleting(false)
  {
  connect(this, SIGNAL(doneChecking(bool, Q_UINT32)),
	  this, SLOT(slotDoneChecking(bool, Q_UINT32)));
  connect(this, SIGNAL(doneDeleting(bool, Q_UINT32)),
	  this, SLOT(slotDoneDeleting(bool, Q_UINT32)));
  }

KNMProtocol::~KNMProtocol()
  {
  disconnect(this, SIGNAL(doneChecking(bool, Q_UINT32)),
	     this, SLOT(slotDoneChecking(bool, Q_UINT32)));
  disconnect(this, SIGNAL(doneDeleting(bool, Q_UINT32)),
	     this, SLOT(slotDoneDeleting(bool, Q_UINT32)));
  }

void KNMProtocol::deleteMessages(QList<KNMMessage> &)
  {
  _deleting = true;
  }

void KNMProtocol::checkMessages()
  {
  _checking = true;
  }

void KNMProtocol::slotDoneChecking(bool, Q_UINT32)
  {
  _checking = false;
  }

void KNMProtocol::slotDoneDeleting(bool, Q_UINT32)
  {
  _deleting = false;
  }
