/***************************************************************************
                         pluginmanager.h  -  description
                             -------------------
    begin                : Sat Apr 28 19:10:24 EDT 2001
    copyright            : (C) 2001 by Mike Pilone
    email                : mpilone@slac.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PLUGIN_MANAGER_H
#define PLUGIN_MANAGER_H

#include <qobject.h>
#include <qstringlist.h>
#include <qstring.h>
#include <qlist.h>
#include <qdict.h>

#include <klibloader.h>

#include "knmplugin.h"

class KConfig;

class PluginManager : public QObject
  {
    Q_OBJECT

      public:
    PluginManager(QObject *parent, const char *name);
    virtual ~PluginManager();
    
    virtual QStringList getPluginList();
    virtual KNMPluginInfo *createPluginInfo(const QString &pluginName);
    virtual KNMPlugin *createPlugin(const QString &pluginName);
    
    static KNMPlugin *findPlugin(Q_UINT32 id, QList<KNMPlugin> &pluginList);

    virtual void readOptions(KConfig &);
    virtual void writeOptions(KConfig &);

    virtual void readPlugins(KConfig &, QList<KNMPlugin> &pluginList);
    virtual void writePlugins(KConfig &, QList<KNMPlugin> &pluginList);

    signals:
    void errorOccured(const QString &accountName,
		    const QString &errorDesc);

      protected:
    virtual QString getManagedPluginType() = 0;
    virtual QString getManagedResourceType() = 0;

    virtual void initPlugin(KNMPlugin *) {}
    
    void loadPlugins();
    
    QDict<KLibrary>    _pluginLibDict;
    QList<KNMPlugin>   _pluginList;
  };

#endif
