#ifndef IMAP_CONFIG_DIALOG_H
#define IMAP_CONFIG_DIALOG_H

#include <qstring.h>

#include <kdialogbase.h>

class QLineEdit;
class QSpinBox;
class QCheckBox;

class ImapConfigDialog : public KDialogBase
  {
  public:
    ImapConfigDialog(const QString &pluginName,
		     const QString &login, const QString &password,
		     const QString &host, const QString &mailboxName,
		     Q_UINT32 port, bool storePassword,
		     QWidget *parent, const char *name);
    ~ImapConfigDialog();

    QString getPluginName() const;
    QString getLogin() const;
    QString getPassword() const;
    QString getHost() const;
    QString getMailboxName() const;
    Q_UINT32 getPort() const;
    bool shouldStorePassword();

  private:
    QLineEdit *_pluginNameEdit;
    QLineEdit *_loginEdit;
    QLineEdit *_mailboxNameEdit;
    QLineEdit *_passwordEdit;
    QLineEdit *_hostEdit;
    QSpinBox  *_portSpinBox;
    QCheckBox *_storePassword;
  };

#endif
