/***************************************************************************
                     knmlocalprotocol.h  -  description
                             -------------------
    begin                : Sat Apr 28 19:10:24 EDT 2001
    copyright            : (C) 2001 by Mike Pilone
    email                : mpilone@slac.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KNM_LOCAL_PROTOCOL_H
#define KNM_LOCAL_PROTOCOL_H

#include <qstring.h>
#include <qlist.h>
#include <qfile.h>
#include <qtimer.h>

#include "knmprotocol.h"
#include "knmmessage.h"

class KConfig;

class KNMLocalProtocol : public KNMProtocol
  {
  Q_OBJECT
  
    public:
  KNMLocalProtocol(QObject *parent, const char *name);
  ~KNMLocalProtocol();
  
  virtual void readOptions(KConfig &);
  virtual void writeOptions(KConfig &);
  
  virtual void deleteMessages(QList<KNMMessage> &msgs);
  virtual void checkMessages();
  virtual void cancelCheck();
  
  virtual QString getLastError();
  virtual QString getAccountName();
    
  virtual bool execConfigDialog(QWidget *parent, const char *name);

 protected slots:
 void slotWorkTimeout();
 
    private:
    QString _spoolFilePath;
    QString _lastError;
    QString _msgBuffer;
    
    QFile _spoolFile;
    QTimer _workTimer;

    Q_UINT32 _numFroms;
  };

#endif
