#include <qlineedit.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qgroupbox.h>

#include <klocale.h>
#include <kurlrequester.h>
#include <klineedit.h>

#include "localconfigdialog.h"

LocalConfigDialog::LocalConfigDialog(const QString &pluginName,
				 const QString &spoolFilePath,
				 QWidget *parent, const char *name)
  : KDialogBase(KDialogBase::Plain, i18n("Local Configuration"),
		KDialogBase::Ok | KDialogBase::Cancel,
		KDialogBase::Ok, parent, name, true, true),
    _pluginNameEdit(NULL), _spoolFilePathEdit(NULL)
  {
  QLabel *label = NULL;
  QGroupBox *box = NULL;
  QFrame *page = plainPage();
  QVBoxLayout *layout = new QVBoxLayout(page);
  layout->setSpacing(3);
  layout->setMargin(2);

  box = new QGroupBox(2, Qt::Horizontal, i18n("General"),
		      page, "box");
  layout->addWidget(box);
  
  label = new QLabel(i18n("Name:"), box);
  
  _pluginNameEdit = new QLineEdit(box, "pluginNameEdit");
  _pluginNameEdit->setText(pluginName);

  box = new QGroupBox(2, Qt::Horizontal, i18n("Local Spool"),
		      page, "box");
  layout->addWidget(box);
  
  label = new QLabel(i18n("Spool File:"), box);

  _spoolFilePathEdit = new KURLRequester(box, "spoolFilePathEdit");
  _spoolFilePathEdit->setURL(spoolFilePath);
  }

LocalConfigDialog::~LocalConfigDialog()
  {
  }

QString LocalConfigDialog::getPluginName() const
  {
  return _pluginNameEdit->text();
  }

QString LocalConfigDialog::getSpoolFilePath() const
  {
  return _spoolFilePathEdit->lineEdit()->text();
  }

