#ifndef POP_CONFIG_DIALOG_H
#define POP_CONFIG_DIALOG_H

#include <qstring.h>

#include <kdialogbase.h>

class QLineEdit;
class QSpinBox;
class QCheckBox;

class PopConfigDialog : public KDialogBase
  {
    public:
  PopConfigDialog(const QString &pluginName,
		  const QString &login, const QString &password,
		  const QString &host, Q_UINT32 port, bool storePassword,
		  QWidget *parent, const char *name);
  ~PopConfigDialog();

  QString getPluginName() const;
  QString getLogin() const;
  QString getPassword() const;
  QString getHost() const;
  Q_UINT32 getPort() const;
  bool shouldStorePassword();

    private:
  QLineEdit *_pluginNameEdit;
  QLineEdit *_loginEdit;
  QLineEdit *_passwordEdit;
  QLineEdit *_hostEdit;
  QSpinBox  *_portSpinBox;
  QCheckBox *_storePassword;
  };

#endif
